]> git.sesse.net Git - backup.sh/blob - backup.sh
If .date becomes invalid, revert to full backup.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # Because of the way we run this script from cron, informational logging goes
15 # to stderr and warnings and errors to stdout. This way, we get mail whenever
16 # stuff fails, and other output is redirected to the log file.
17
18 # The script is halfway Norwegian and halfway English. Newer modifications are
19 # in English, we should probably stick to that.
20
21 # The computer to backup.
22 computer=$1
23
24 # Configuration
25 LOCKFILE=/home/backup/backuprun.lockfile.$computer
26 confdir=/home/backup/conf/              # Configuration files
27 storagedir=/backup                      # Where we keep backups
28 maxnumfull=3                            # Number of full backups
29 daysbetweenfull=30                      # Days between full backups
30 daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
31                                         # full-backup date (in case the fixed day gets missed)
32 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
33 DATE=`date "+%Y%m%d%H%M"`               #format: touch
34 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
35
36 # Exclude-pattern
37 exclude=$confdir/exclude
38 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
39
40 if [ -z "$computer" ]; then
41         echo "Usage: $0 COMPUTER"
42         exit 1
43 fi
44
45 # Die more or less gracefully (at least notify user)
46 die() {
47         echo `date`": Something nasty happened."
48         rm $LOCKFILE
49         exit 1
50 }
51 diemsg() {
52         echo `date`": $computer: $@"
53         die
54 }
55
56 # Trap C-c and kill
57 trap die SIGINT SIGTERM
58
59 # Don't start if we're already running
60 if [ -e $LOCKFILE ]; then
61         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
62         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
63         exit 1
64 fi;
65 touch $LOCKFILE
66 echo $$ > $LOCKFILE
67
68 echo `date`": Backup run starting" >&2
69
70 umask 027
71
72
73 backup()
74 {
75         echo -n `date` >&2
76         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
77
78         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
79         incrementalsnar="/root/.backup/${sfilesystem}.snar"
80         if [ "$backuplevel" = "daglig" ]
81         then
82                 # If incremental backup, we need to copy the incremental status to $computer.
83                 # If it does not exist, whine a bit and then run date-based instead.
84                 if [ -s "$SNARFILE" ]; then
85                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
86                                 diemsg "Could not copy .incremental.snar to $computer"
87                         fi
88                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
89                 else
90                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
91                         incrementalsnar=""
92                         lastd=`cat ../.date`
93                         lastcmd="--newer='$lastd'"
94                 fi
95         else
96                 lastcmd="--listed-incremental=$incrementalsnar"
97         fi
98
99         # We try to run tar on the remote computer
100         #    c create archive
101         #    C change to directory first
102         #    . where to start taring (see C)
103         #    $lastcmd only files newer than this
104         #    --one-file-system don't traverse file systems
105         #    --use-compress-program compress it using gzip or pigz
106         #    --exclude-from file to get exclusion pattern from
107         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
108         #    file and build a file list, respectivly.  
109         TARFILE=$DATE.tmp
110         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
111                 --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
112         echo `date`" $computer: Running $TARCMD" >&2
113         eval $TARCMD > $DATE.idx
114
115         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
116                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
117  
118                 if [ "$incrementalsnar" ]; then
119                         if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
120                                 diemsg "Could not copy .incremental.snar from $computer"
121                         fi
122                 fi
123
124                 # Move tar file in place
125                 mv $TARFILE $DATE.tgz
126                 mv $SNARFILE.tmp $SNARFILE
127
128                 # Update timestamp
129                 echo $DATEs > ../.date && touch -t $DATE ../.date
130
131                 # Make a sorted file list as well
132                 sort -k6 < $DATE.idx > $DATE.sdx
133
134                 # Fix permissions
135                 chmod 600 *tgz                      #only for us
136                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
137
138                 # Let the remote computer know that we ran a successful backup (for nagios)
139                 ssh root@$computer touch $filesystem/.lastbackup
140         else
141                 # Something wrong happened.
142                 rm $TARFILE
143                 diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
144         fi
145 }
146
147 # Check that the target filesystem is mounted (actually check that it's not
148 # the root filesystem)
149 if [ ! -d "$storagedir/$computer" ]; then
150         diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
151 fi
152 rootfilesystem=`df -P /`
153 targetfilesystem=`df -P "$storagedir/$computer"`
154 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
155         diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
156 fi
157
158 echo `date`" $computer: Backing up $computer" >&2
159
160 # Try to SSH to the computer without entering a password.
161 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
162         diemsg "Could not use passwordless SSH."
163 fi
164
165 # Check if pigz is available
166 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
167         compressor=pigz
168 else
169         echo `date`" $computer: pigz missing; falling back to gzip."
170         compressor=gzip
171 fi
172
173 # Check dump bit in fstab
174 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
175         | grep -v nfs \
176         | grep -v "^#" \
177         | grep -v "^$" \
178         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
179
180 # Clean up our dir at this client
181 if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
182         diemsg "Could not create backup staging area at $computer:/root/.backup"
183 fi
184
185 # Try to copy $exclude to $computer
186 if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
187         diemsg "Could not copy exclude.txt to $computer"
188 fi
189
190 # Try to copy preeexec and postexec if they exist
191 if [ -f $confdir/preexec.$computer ]; then
192         if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
193                 diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
194         fi
195 fi
196 if [ -f $confdir/postexec.$computer ]; then
197         if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
198                 diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
199         fi
200 fi
201
202 # Try to run preexec if it exists
203 if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
204         diemsg "Could not run $computer:/root/.backup/preexec"
205 fi
206
207 for filesystem in $filesystems; do
208         # Remove / and $ (for Windows) for path names
209         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
210
211         # Prepare storage area
212         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
213         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
214
215         # Default backuplevel
216         backuplevel=daglig
217
218         if [ ! -s $storagedir/$computer/$sfilesystem/.date ]
219         then
220                 # Take the first full backup of this filesystem on this computer
221                 backuplevel=full
222                 echo $DATEs > $storagedir/$computer/$sfilesystem/.date
223         fi
224
225         # Check if we want a full backup
226         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
227                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
228                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
229                         backuplevel=full
230                 fi
231         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
232                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
233                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
234                         backuplevel=full
235                 fi
236         else
237                 fullbackup_min_for_this_machine=$daysbetweenfull 
238         fi
239
240         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
241                 backuplevel=full
242         fi
243
244         # We want to be here
245         cd $storagedir/$computer/$sfilesystem/$backuplevelmsg || die "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
246
247         # Perform the actual backup
248         backup
249
250         # Check if this box has a custom number of full backups
251         if [ -f $confdir/maksfulle.$computer.$sfilesystem ]; then
252                 mf=$((`cat $confdir/maksfulle.$computer`+1))
253         elif [ -f $confdir/maksfulle.$computer ] ; then
254                 mf=$((`cat $confdir/maksfulle.$computer`+1))
255         else
256                 mf=$(($maxnumfull+1))
257         fi
258
259         # Delete old full backups
260         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
261                 prefix=`echo $full | sed "s/\.[^.]*$//"`
262                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
263                 rm $prefix*
264         done
265
266         # Delete incremental backups older than the oldest full backup
267         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
268         find \
269                 $storagedir/$computer/$sfilesystem/daglig \
270                 -type f \
271                 \! -newer $oldf \
272                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
273                 -exec rm {} \; >&2
274 done
275
276 # Try to run postexec if it exist
277 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
278         diemsg "Could not run $computer:/root/.backup/postexec"
279 fi
280
281 # Remove lockfile
282 rm $LOCKFILE